/******************************************************************************
/* Absicht des Programms: In diesem Programm wird das Verfahren A
/*                        der Aufgabe 2 vom bungsblatt 7.
/* Programmbersicht:     Aus der Datei werden die 1629 Temperaturen in einen
/*                        Array eingelesen.
/*                        Dann wird im Array das Maximum gesucht.
/*******************************************************************************/

#include <fstream>
#include <iostream>
using namespace std;

int main (void)
{
    //Deklaration der Variablen
    ifstream datei;  //Strom zum Einlesen aus einer Datei
    float temperatur[1629]; //Gleitkommazahlige Array fr die Temperaturen
    float maximum; //Variable frs Speichern des Maximums
    unsigned short i;      //Zhlervariable fr die Schleifen
    
    //Die Stromvariable stellt eine Verbindung mit "temp.dat" her
    //AUFPASSEN darauf, dass die Datei im selben Ordner als die ausfhrbare Datei
    // des Programms ist.
    datei.open("temp1629.dat");
    
    //Durch die Schleife wird jeweils eine Temperatur in eine Position des Arrays
    // eingelesen.
    for (i = 0; i < 1629; i++)
    {
        datei >> temperatur[i];
    }
    
    //Wenn ich die Datei nicht mehr brauche, schliesse ich die Datei
    datei.close();
    
    //Das Maximum wird gesucht
    //ALGORITHMUS
    //Anfangsschritt: das Maximum befindet sich in der ersten Position des Arrays
    maximum = temperatur[0];
    
    for (i = 1; i < 1629; i++)
    {
        //Vergleich jeden weiteren Elements des Arrays mit dem Maximum
        //Falls das neue Element grer als Maximum ist, wird es das neue Maximum
        if ( temperatur[i] > maximum )
        {
             maximum = temperatur[i];
        }
        //Ohne ELSE! Ansonten weiter!
    }
    
    cout << "Die maximale erreichte Temperatur des Stirnradgetriebes ist: " << maximum;
    cout << endl;
    
    system("pause");
    
    return 0;
}
    
    
    
    
