/*******************************************************************
/* Programmbersicht: Implementierung des Struktogramms vom Aufgabe 3
/*                    des bungsblatts 7.
/*                    Eine binre Suche wird deshalb implementiert,
/*                    die die eingegebene Matrikelnummer in allen
/*                    Matrikelnummer der Datei sucht.
/********************************************************************/

#include <iostream>
#include <fstream>
using namespace std;

int main (void)
{
    ifstream matrikelDatei;
    unsigned int gesucht;
    int i, erste = 0, letzte = 4999, mitte, position = -1;
    unsigned int matrikelnr[5000];
    
    cout << "Geben Sie die Matrikelnummer des Studenten ein, \n";
    cout << "um zu wissen, ob der Student das Studium abgeschlossen hat." << endl;
    
    cin >> gesucht;
    
    //Die Datei der Matrikelnnummer wird mit der Stromvariable geffnet 
    matrikelDatei.open("AbschlussMatrikel.dat");
    
    //Die Matrikelnummer werden in einen Array eingelesen
    for (i=erste; i<=letzte; i++)
    {
        matrikelDatei >> matrikelnr[i];
    }
    //Die Verbindung mit der Datei wird getrennt.
    matrikelDatei.close();
    
    //Binre Suche der eingegebenen Matrikelnummer "gesucht"
    //im Array "matrikelnr"
    //Implementierung des Struktogramms

     while (erste <= letzte)
     {
           //Berechnung der Mitteposition des untersuchten Arraysstcks
            mitte = erste + ((letzte - erste) / 2);
            
            //Ermittlung der Position des gesuchten Elements ab der Mitteposition
            //des Arraysstcks.
            if (matrikelnr[mitte] < gesucht )
            {
                erste = mitte + 1; // rechts weitersuchen
            }
            else if (matrikelnr[mitte] > gesucht )
            {
                letzte = mitte - 1; // links weitersuchen
            } 
            else
            {
                position = mitte; // Zeichen im Array gefunden
                break; //Schleife wird somit abgebrochen.
            }
        }

     //Wenn das Array nicht gefunden worden ist. Der initialisierte Wert fr die
     //Position (-1) hat sich nicht gendert.
     if (position == -1)
     {
        cout << "Nicht gefunden!" << endl;
        cout << "Der Student mit Matrikelnummer " << gesucht << " hat das Studium nicht abgeschlossen" << endl;
     }
     else
     {
         cout << "Gefunden in position " << position << endl;
         cout << "Der Student mit Matrikelnummer " << gesucht << " hat das Studium abgeschlossen" << endl;
         
     }
     
     system("pause");
     return 0;
}
     
