/******************************************************************************
/* Absicht des Programms: In diesem Programm wird das Verfahren B
/*                        der Aufgabe 2 vom bungsblatt 7.
/* Programmbersicht:     Die Datei mit den Temperaturen wird untersucht auf die
/*                        Suche nach dem Maximum.
/*                        Alles ohne Hilfsarray.
/*******************************************************************************/

#include <fstream>
#include <iostream>
using namespace std;

int main (void)
{
    //Deklaration der Variablen
    ifstream datei;  //Strom zum Einlesen aus einer Datei
    float temperatur, maximum; //Variable frs Speichern des Maximums
    unsigned short i;      //Zhlervariable fr die Schleifen
    
    //Die Stromvariable stellt eine Verbindung mit "temp.dat" her
    //AUFPASSEN darauf, dass die Datei im selben Ordner als die ausfhrbare Datei
    // des Programms ist.
    datei.open("temp1629.dat");
    
    //Das Maximum wird gesucht
    //ALGORITHMUS
    //Anfangsschritt: das Maximum befindet sich in der ersten eingelesenen Temperatur
    datei >> maximum;
    
    //Durch die Schleife wird jeweils eine Temperatur eingelesen und untersucht um das Maximum zu ermitteln
    for (i = 0; i < 1629; i++)
    {
        //Eine weitere Temperatur wird aus der Datei eingelesen.
        datei >> temperatur;
        
        //Vergleich jeder weiterer Temperatur der Datei mit dem Maximum
        //Falls die neue Temperatur grer als Maximum ist, wird sie das neue Maximum
        if ( temperatur > maximum )
        {
             maximum = temperatur;
        }
        //Ohne ELSE! Ansonten weiter!
        
    }
    
    //Wenn ich die Datei nicht mehr brauche, schliesse ich die Datei
    datei.close();
    
    cout << "Die maximale erreichte Temperatur des Stirnradgetriebes ist: " << maximum;
    cout << endl;
    
    system("pause");
    
    return 0;
}
    
    
    
    
